// POP3.cpp: implementation of the POP3 class.
//
//////////////////////////////////////////////////////////////////////

#include "Stdafx.h"
#include "Traymail.h"
#include "POP3.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define  CHK(x) if(!x) GetLastError();
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

POP3::POP3
(
const char *UserName,
const char *ServerName,
const char *Password		   
)
{
	strcpy ( m_szPassword, Password );
	strcpy ( m_szServerName, ServerName );
	strcpy ( m_szUserName, UserName );

	AfxSocketInit();

	//CheckMail ( NULL, NULL, TRUE );
}

POP3::~POP3()
{
	// sock.Close() is called by destructor
}

BOOL POP3::CheckMail(
	BOOL * pfResult,
	char * sToolTip,
	BOOL bGui
	)
{
	CSocket sock;

	char InBuff[10000];
	char OutBuff[200];
	int cbLen;

	char TraceBuff[100];

	TRACE ( ">>>>CheckMail\n" );

	sock.Create();

	if ( !sock.Connect( m_szServerName, 110 ) )
	{
		if ( bGui )
		{
			sprintf ( TraceBuff, "Couldn't find %s", m_szServerName );
			::MessageBox ( NULL, TraceBuff, AfxGetApp()->m_pszExeName, MB_OK );
		}
		
		TRACE ( "<<<<CheckMail (bad server)\n" );
		return( FALSE );
	}

	sock.Receive( InBuff, sizeof ( InBuff ) );
	//TRACE ( InBuff );
	
	// send the user name
	cbLen = wsprintf ( OutBuff, "USER %s\r\n", m_szUserName );
	//TRACE ( OutBuff);
	sock.Send ( OutBuff, cbLen);
	sock.Receive ( InBuff, sizeof ( InBuff ) );
	//TRACE ( InBuff );

	// send the password
	cbLen = wsprintf ( OutBuff, "PASS %s\r\n", m_szPassword );
	//TRACE ( OutBuff);
	sock.Send ( OutBuff, cbLen);
	sock.Receive ( InBuff, sizeof ( InBuff ) );
	//TRACE ( InBuff );
	
	if ( InBuff[0] != '+' )
	{
		if ( bGui )
		{
			::MessageBox ( NULL, "Bad user name / password" , AfxGetApp()->m_pszExeName, MB_OK );
		}
		TRACE ( "<<<<CheckMail (Bad user name / password)\n" );
		return( FALSE );
	}
	// see if we have messages
	strcpy ( OutBuff, "TOP 1 0\r\n" );
	//TRACE ( OutBuff);
	sock.Send ( OutBuff, strlen(OutBuff));
	sock.Receive ( InBuff, sizeof ( InBuff ) );
	//TRACE ( InBuff );	

	if ( InBuff[0] == '-' )
	{
		if ( pfResult)
			*pfResult = FALSE;

		if ( sToolTip )
			strcpy ( sToolTip, "No Messages" );
	}
	else
	{
		if ( pfResult)
			*pfResult= TRUE;
		
		//afxDump << InBuff ;
		char *pStart, *pEnd;
		
		do
		{
			sock.Receive ( InBuff, sizeof ( InBuff ) );

#ifdef _DEBUG
			afxDump << "Buffer={\n" << InBuff << "\n}End Buffer\n";
#endif
			
			if ( pStart=strstr ( InBuff, POP_SUBJECT ) )
			{
				pStart += strlen ( POP_SUBJECT );

				pEnd = strstr ( pStart, "\r\n" );

				if ( pEnd )
				{
				*pEnd=0;
				TRACE ( "Subject = <%s>\n", pStart  );
				if ( sToolTip )
					strcpy ( sToolTip, pStart );
				}

				break;

			}
				
			
		}
		while ( ! strstr ( InBuff, POP_EOF ) );
		
	}


	strcpy ( OutBuff, "QUIT\r\n" );
	//TRACE ( OutBuff);
	sock.Send ( OutBuff, strlen(OutBuff));
	sock.Receive ( InBuff, sizeof ( InBuff ) );
	//TRACE ( InBuff );	

	sock.Close();

	TRACE ( "<<<<CheckMail (Success)\n" );

	return ( 1 );

}


BOOL POP3::TestConnection()
{
	return ( CheckMail ( NULL, NULL, TRUE ) );
}
