// Traymail.cpp : Defines the class behaviors for the application.
//           Traymail is a simple program which consists of a main window
//           and an "About" dialog which can be invoked by a menu choice.
//           It is intended to serve as a starting-point for new
//           applications.
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "resource.h"

#include "Traymail.h"
#include "POP3Conf.h"

#include <string.h>
#include <stdio.h>

#define SAFESTR(X) X?X:""

#include "aboutdlg.h"
#include "POP3.h"

/////////////////////////////////////////////////////////////////////////////

// theApp:
// Just creating this application object runs the whole application.
//
CTheApp NEAR theApp;
NOTIFYICONDATA nid;
HICON hIconMain;
HICON hIconMainCheck;
HICON hIconBlank;

/////////////////////////////////////////////////////////////////////////////

// CMainWindow constructor:
// Create the window with the appropriate style, size, menu, etc.
//
CMainWindow::CMainWindow()
{
	LoadFrame(IDR_MAINFRAME);
	// Timer Zero is used to flash the icon
	SetTimer ( 0, 500, NULL );
	// Timer One is used to check for mail
	SetTimer ( 1, 30000, NULL );
	
	pConnection = new POP3( 
		theApp.m_szUserName,
		theApp.m_szServerName,
		theApp.m_szPassword );


	CheckForMail();



}

// OnPaint:
// This routine draws the string "Traymail, Windows!" in the center of the
// client area.  It is called whenever Windows sends a WM_PAINT message.
// Note that creating a CPaintDC automatically does a BeginPaint and
// an EndPaint call is done when it is destroyed at the end of this
// function.  CPaintDC's constructor needs the window (this).
//
void CMainWindow::OnPaint()
{
	CRect rect;
	GetClientRect(rect);

	CPaintDC dc(this);
	dc.SetTextAlign(TA_BASELINE | TA_CENTER);
	dc.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dc.SetBkMode(TRANSPARENT);
	CString s;
	s.LoadString(IDS_TRAYMAIL);
	dc.TextOut((rect.right / 2), (rect.bottom / 2), s);
}

// OnAbout:
// This member function is called when a WM_COMMAND message with an
// ID_APP_ABOUT code is received by the CMainWindow class object.   The
// message map below is responsible for this routing.
//
// We create a ClDialog object using the "AboutBox" resource (see
// Traymail.rc), and invoke it.
//
void CMainWindow::OnAbout()
{
	CDialog about(IDD_ABOUTBOX);
	about.DoModal();
}

// CMainWindow message map:
// Associate messages with member functions.
//
// It is implied that the ON_WM_PAINT macro expects a member function
// "void OnPaint()".
//
// It is implied that members connected with the ON_COMMAND macro
// receive no arguments and are void of return type, e.g., "void OnAbout()".
//
BEGIN_MESSAGE_MAP( CMainWindow, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWindow )
	ON_WM_PAINT()
	ON_COMMAND(ID_APP_ABOUT, OnAbout)
	ON_MESSAGE( MYWM_NOTIFYICON	, OnNotifyIcon )
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTheApp

// InitInstance:
// When any CTheApp object is created, this member function is automatically
// called.  Any data may be set up at this point.
//
// Also, the main window of the application should be created and shown here.
// Return TRUE if the initialization is successful.
//
BOOL CTheApp::InitInstance()
{
	char delim[] = " ,\t\n";
	char *param;


	TRACE0("CTheApp::InitInstance\n");
	
	Enable3dControls(); // use 3d controls in dialogs

	m_szPassword[0]=m_szUserName[0]=m_szServerName[0]=0;

	param = strtok ( m_lpCmdLine, delim );

	while ( param )
	{
		if ( !strncmp ( param, "-u", 2 ) )
		{
			param = strtok ( NULL, delim );
			if ( param )
				strcpy ( m_szUserName, param );
			else 
				break;
		}

		if ( !strncmp ( param, "-s", 2 ) )
		{
			param = strtok ( NULL, delim );
			if ( param )
				strcpy ( m_szServerName, param );
			else 
				break;
		}

		if ( !strncmp ( param, "-p", 2 ) )
		{
			param = strtok ( NULL, delim );
			if ( param )
				strcpy (m_szPassword, param );
			else 
				break;
		}

		param = strtok ( NULL, delim );

	}

	//TRACE ( "UserName=%s, ServerName=%s, Password=%s\n",
	//	m_szUserName, m_szServerName, m_szPassword );

	SetRegistryKey ( _T("Ridgecrop Consultants Ltd") );

	char buf[200];

	
	//Crypto ( m_szPassword, buf );

	// if we didn't have a command line try to read the 
	// params from the registry
	if ( !strlen(m_szPassword ) )
	{
		CString temp = GetProfileString ( "", "Password", "" );
		strcpy ( m_szPassword, Crypto ((LPCTSTR)temp,buf) );
	}
	

	if ( !strlen( m_szUserName ) )
		strcpy ( m_szUserName, GetProfileString ( "", "UserName", "" ) );
	
	if ( !strlen ( m_szServerName ) )
		strcpy ( m_szServerName, GetProfileString ( "", "Server", "" ) );



	

//	if ( !strlen (m_szUserName) || !strlen(m_szServerName) || !strlen(m_szPassword )  )
//	{
//	char Buff[200];
//
//		sprintf ( Buff, 
//			"Usage: %s -u <UserName> -p <Password> -s <Server>\n",
//			m_pszExeName );
//
//		::MessageBox ( NULL, Buff, m_pszExeName, MB_OK );
//			
//		return ( FALSE );
//		
//	}

	POP3 TempConnection ( 
		m_szUserName,
		m_szServerName,
		m_szPassword );

	CPOP3Conf dlg;

	// do we have any info at all ?
	if ( strlen (m_szUserName) || strlen(m_szServerName) || strlen(m_szPassword )  )
	{
		// yes - test the connection
		if ( !TempConnection.TestConnection() )
		{
			dlg.m_sPassword = m_szPassword;
			dlg.m_sUserName = m_szUserName;
			dlg.m_sServerName = m_szServerName;

			if ( dlg.DoModal() != IDOK )
				return( FALSE );

			strcpy ( m_szPassword, dlg.m_sPassword);
			strcpy ( m_szUserName, dlg.m_sUserName);
			strcpy ( m_szServerName, dlg.m_sServerName );

		}
	}
	else
	// otherwise start from scratch - guess the username
	// and server name, leave the password blank
	{
		char Buf[100];
		DWORD Length=sizeof( Buf);

		dlg.m_sPassword = "";
		GetUserName ( Buf, &Length );
		dlg.m_sUserName = Buf;
		dlg.m_sServerName = "";

		if ( dlg.DoModal() != IDOK )
				return( FALSE );

		strcpy ( m_szPassword, dlg.m_sPassword);
		strcpy ( m_szUserName, dlg.m_sUserName);
		strcpy ( m_szServerName, dlg.m_sServerName );


	}

	// update the registry
	Crypto (m_szPassword,buf);
	AfxGetApp()->WriteProfileString ( "", "Password", buf );

	AfxGetApp()->WriteProfileString ( "", "UserName", m_szUserName );

	AfxGetApp()->WriteProfileString ( "", "Server", m_szServerName );
	
	// now we can start up
	m_pMainWnd = new CMainWindow;

	// hide the window initially

	//m_pMainWnd->ShowWindow(m_nCmdShow);
	//m_pMainWnd->UpdateWindow();

	hIconMain = (HICON)::LoadImage ( AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16,16, 0 );
	hIconBlank = (HICON)::LoadImage ( AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDI_BLANK), IMAGE_ICON,16,16,0);
	hIconMainCheck = (HICON)::LoadImage ( AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME_CHECK), IMAGE_ICON, 16,16, 0 );

	nid.cbSize = sizeof ( nid );
	nid.hWnd= m_pMainWnd->GetSafeHwnd();
	nid.uID = 0;
	nid.uFlags = NIF_ICON  | NIF_MESSAGE | NIF_TIP ;
	nid.uCallbackMessage = MYWM_NOTIFYICON;
	nid.hIcon = hIconMain;
	strcpy ( nid.szTip, "" );

	Shell_NotifyIcon ( 
		NIM_ADD, 
		&nid );

	return TRUE;
}


int CTheApp::ExitInstance()
{
	Shell_NotifyIcon ( 
		NIM_DELETE, 
		&nid );

	return(TRUE);
}

void CMainWindow::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
  
	if ( !nIDEvent )
	{
	// flash the icon
	if ( bMessageFlag )
		{
		nid.hIcon = ( nid.hIcon == hIconMain ) ? hIconBlank: hIconMain;
		strncpy ( nid.szTip, szToolTip, 63 );

		Shell_NotifyIcon ( 
			NIM_MODIFY, 
			&nid );
		}
	else
		{
		// update tips and make sure the icon is ok
		if ( nid.hIcon == hIconBlank )
			nid.hIcon = hIconMain;

		strncpy ( nid.szTip, szToolTip, 63 );

		Shell_NotifyIcon ( 
			NIM_MODIFY, 
			&nid );
		}
	}
	else
	{
		CheckForMail();	
	}
	CFrameWnd ::OnTimer(nIDEvent);
	
}

LRESULT CMainWindow::OnNotifyIcon(WPARAM WParam, LPARAM LParam)
{
	switch ( LParam )
	{
	case WM_LBUTTONDOWN:

		CheckForMail();

		break;

	case WM_RBUTTONDOWN:

		CAboutDlg dlg;

		if ( dlg.DoModal() == IDEXIT ) 
			DestroyWindow();

		break;
	}

	return(TRUE);
}

CMainWindow::~CMainWindow()
{
	delete pConnection;

	//KillTimer(0);
	//KillTimer(1);
}




#define _SIZE(X) (sizeof(X)-1)
#define KEY(X) (key[X%_SIZE(X)])
char * CTheApp::Crypto(const char * in, char * tempbuff)
{
	char *ptr=tempbuff;
	int index=0;
	char key[]="Twasbrillig";

	while ( *in )
	{
		*ptr=*in ^ KEY(index) ^ KEY(_SIZE(key)-index)  ^0xc0;
		ptr++;in++;index++;
	}
	*ptr++=0;
	return ( tempbuff );
}

void CMainWindow::NewMailDude()
{
	MessageBeep ( 0xffffffff );
}

void CMainWindow::CheckForMail()
{

	// start at -1
	static LONG fChecking=-1;

	// first increment takes us to zero if not owned
	if ( InterlockedIncrement( &fChecking ) )
		// otherwise we're already checking
		{
		// reduce the lock count and return
		InterlockedDecrement( &fChecking);
		return;
		}

	BOOL bOldMessageFlag = bMessageFlag;	

	HICON hIconOld = ( nid.hIcon != hIconMainCheck ) ? nid.hIcon : hIconMain ;
	
	nid.hIcon = hIconMainCheck;

	Shell_NotifyIcon ( 
			NIM_MODIFY, 
			&nid );

	// if we got a connection then ungray the icon
	if ( pConnection->CheckMail (&bMessageFlag,szToolTip) )
	{
		nid.hIcon = hIconOld;
		
		strncpy ( nid.szTip, szToolTip, 63 );

		Shell_NotifyIcon ( 
			NIM_MODIFY, 
			&nid );

	if ( !bOldMessageFlag && bMessageFlag  ) 
		{
		NewMailDude();	
		;
		}
	

	}


	

	// decrement the lock
	InterlockedDecrement ( &fChecking );
}
